// DemoEventInfo.cpp : Defines the entry point for the console application.
//


#include <iostream>

using namespace std;

#include <CL/opencl.h>

const char* program_source[] =
{
	"__kernel void Hello()",
	"{",
		"long i;",
		"float f;",
		"for(i=0 ; i<10000000; i++)",
		"	f = sin(0.5) + cos (0.4) + tan (0.3);",	
	"}",
};

int main(int argc, char **argv)
{
	const cl_uint num_entries = 10;
	cl_platform_id platforms[num_entries];
	cl_uint num_platforms;
	clGetPlatformIDs(num_entries, platforms, &num_platforms);

	cout << "Demo EventInfo" << endl;
	
	// Obtenir les devices de la premire 
	// plate-forme trouve
	cl_device_id devices[num_entries];
	cl_uint num_devices;
	clGetDeviceIDs(platforms[0], CL_DEVICE_TYPE_GPU, num_entries, devices, &num_devices);


	// La table de proprits pour la fonction
	// clCreateContext
	cl_context_properties properties[] =
	{ 
		CL_CONTEXT_PLATFORM,
		(cl_context_properties)platforms[0], // la premire plate-forme
		0 
	};

	
	cl_int error;
	cl_context context = clCreateContext(properties,
							num_devices, devices,
							NULL, NULL, &error);

	if(error != CL_SUCCESS)
	{
		cerr << "Erreur clCreateContext" << endl;
		return 1;
	}

	cl_command_queue command_queue = clCreateCommandQueue (context,
										devices[0],
										NULL, &error);

	if(error != CL_SUCCESS)
	{
		cerr << "Erreur clCreateCommandQueue" << endl;
		clReleaseContext(context);
		return 1;
	}

	cl_program program = clCreateProgramWithSource(
		context,
		sizeof(program_source)/sizeof(char*),
		program_source,
		NULL,
		&error);

	
	cl_int result = clBuildProgram(program, 0, NULL, NULL, NULL, NULL);
	cl_kernel kernel_hello = clCreateKernel(program, "Hello", NULL);


	
	const size_t global_work_size_hello[] = {
		500,
	};
	cl_event eventa;
	cl_event event_list[1];
	cl_uint num = sizeof(event_list)/sizeof(cl_event);

	result = clEnqueueNDRangeKernel (command_queue,
					kernel_hello,
					1,
					NULL,
					global_work_size_hello,
					NULL, 0, NULL, &eventa);

	event_list[0] = eventa;
	cl_int status;

	result = clGetEventInfo(eventa,
			CL_EVENT_COMMAND_EXECUTION_STATUS,
			sizeof(cl_int),
			&status,
			NULL);
		cout << status << endl;

	result = clWaitForEvents (num, event_list);

	result = clGetEventInfo(eventa,
			CL_EVENT_COMMAND_EXECUTION_STATUS,
			sizeof(cl_int),
			&status,
			NULL);
		cout << status << endl;


	cout << "Fin demo EventInfo" << endl; 


	clReleaseEvent(eventa);
	clReleaseKernel(kernel_hello);
	clReleaseProgram(program);
	clReleaseCommandQueue(command_queue);		
	clReleaseContext(context);

	//cin.get();
}