
#include <iostream>

using namespace std;

#include <CL/opencl.h>


int main(int argc, const char** argv) 
{
	cl_int result;
	
	// Obtenir les identifiants de plates-formes
	const cl_uint num_entries = 10;
	cl_platform_id platforms[num_entries];
	cl_uint num_platforms;
	result = clGetPlatformIDs(num_entries, platforms, &num_platforms);
	if(result != CL_SUCCESS)
	{
			cerr << "Erreur clGetPlatformIDs" << endl;
			return 1;
	}
	cout << num_platforms << " plates-formes detectees" << endl << endl;

	// Obtenir les infos sur les plates-formes
	const size_t size_buffer = 255;
	char buffer[size_buffer+1];
	size_t param_value_size_ret;
	for(cl_uint i=0; i< num_platforms; i++)
	{
		clGetPlatformInfo(platforms[i], CL_PLATFORM_PROFILE, size_buffer, buffer, &param_value_size_ret);
		cout << "CL_PLATFORM_PROFILE: " << buffer << endl;

		clGetPlatformInfo(platforms[i], CL_PLATFORM_VERSION, size_buffer, buffer, &param_value_size_ret);
		cout << "CL_PLATFORM_VERSION: " << buffer << endl;

		clGetPlatformInfo(platforms[i], CL_PLATFORM_NAME, size_buffer, buffer, &param_value_size_ret);
		cout << "CL_PLATFORM_NAME: " << buffer << endl;
		
		clGetPlatformInfo(platforms[i], CL_PLATFORM_VENDOR, size_buffer, buffer, &param_value_size_ret);
		cout << "CL_PLATFORM_VENDOR: " << buffer << endl;
		
		cout << endl;
		clGetPlatformInfo(platforms[i], CL_PLATFORM_EXTENSIONS, size_buffer, buffer, &param_value_size_ret);
		cout << "CL_PLATFORM_EXTENSIONS: " << buffer << endl;

	}

	// Obtenir les informations sur les devices de
	// la plate-forme  l'indice 0

	cl_device_id devices[num_entries];
	cl_uint num_devices;

	cout  << endl << "-------------------------" << endl << endl;
	result = clGetDeviceIDs(platforms[0], CL_DEVICE_TYPE_ALL, num_entries, devices, &num_devices);
	if(result != CL_SUCCESS)
	{
			cerr << "Erreur clGetDeviceIDs" << endl;
			return 1;
	}
	for(cl_uint i=0; i< num_devices; i++)
	{
		clGetDeviceInfo(devices[i], CL_DEVICE_TYPE, size_buffer, buffer, &param_value_size_ret);
		int value = (int)buffer[0];
		if(value & CL_DEVICE_TYPE_CPU)
			cout << "CL_DEVICE_TYPE: " << "CL_DEVICE_TYPE_CPU" << endl;
		if(value & CL_DEVICE_TYPE_GPU)
			cout << "CL_DEVICE_TYPE: " << "CL_DEVICE_TYPE_GPU" << endl;

		clGetDeviceInfo(devices[i], CL_DEVICE_NAME, size_buffer, buffer, &param_value_size_ret);
		cout << "CL_DEVICE_NAME: " << buffer << endl;

		clGetDeviceInfo(devices[i], CL_DEVICE_VENDOR, size_buffer, buffer, &param_value_size_ret);
		cout << "CL_DEVICE_VENDOR: " << buffer << endl;

		clGetDeviceInfo(devices[i], CL_DEVICE_COMPILER_AVAILABLE, size_buffer, buffer, &param_value_size_ret);
		value = (int)buffer[0];
		if(value == 1)
			cout << "CL_DEVICE_COMPILER_AVAILABLE: " << " ok" << endl;

		cout << endl << "-------------------------" << endl;
	}

	return 0;
}
